Subject: bug#40273: installer: No way to input Latin characters with non-Latin keyboard layouts

From: "pelzflorian (Florian Pelz)" <[email-masked]>
Date: Fri, 3 Apr 2020 17:56:30 +0200

On Fri, Apr 03, 2020 at 05:20:23PM +0200, Ludovic Courtès wrote:
> > GDM retains my U.S. English layout even after herd stop xorg-server
> 
> That’s a regression.  Localed was added exactly one year ago to fix this
> problem in commit 607fcc75404e2b1fc74affcf372b4a6a789ac55e.  I’ve spent
> a couple of hours investigating and I don’t know why it doesn’t work,
> especially since it works fine once logged in in GNOME (it’s the same
> code, GNOME Shell).

Sorry!  It is entirely my fault.  I had not known that if I don’t put
a keyboard-layout field in set-xorg-configuration, I always get
U.S. layout.

> OTOH, it has the potential of breaking things here and there; also, I’d
> rather stay close to XKB.
> 
> If that’s fine with you, I propose applying that patch and adding a
> sentence in “Keyboard Layout” to document that.

I agree that staying close to XKB is a good reason.

Thank you for all your work!!

> 
> >> However, I noticed that this doesn’t work in GRUB.  Actually, even
> >> (keyboard-layout "fr") doesn’t work in GRUB (at the command line after
> >> the boot menu), which seems like a regression.
> >
> > I suppose on GRUB using at_keyboard it worked in the past?
> >
> > For me there’s no regression because keyboard layouts never worked
> > (using usb keyboard rather than at keyboard), see
> > <https://issues.guix.info/issue/35585#9>.
> 
> Damn it, so it’s this ‘terminal_input’ directive that broke it?

I can only use the usb_keyboard input terminal and cannot use
at_keyboard with my Macbook.  Not specifying a terminal_input was the
right resolution for that bug, because now it uses usb_keyboard
automatically.

It’s just that usb_keyboard cannot use keyboard layouts, it seems, and
overall GRUB does not support all features needed from keyboard
layouts according to the manual.  Not encrypting grub’s file system
seems easier.

Regards,
Florian